### Class

# Gck Enumerator

#### Description [src]

    final class Gck.Enumerator : GObject.Object
    {
      /* No available fields */
    }

Can be used to enumerate through PKCS#11 objects. It will automatically create sessions as necessary.

Use `gck_modules_enumerate_objects()` or `gck_modules_enumerate_uri()` to create an enumerator. To get the objects, use `gck_enumerator_next()` or `gck_enumerator_next_async()` functions.

#### Ancestors

- GObject

#### Instance methods

###### gck_enumerator_get_chained

Get the enumerator that will be run after all objects from this one are seen.

###### gck_enumerator_get_interaction

Get the interaction used when a pin is needed.

###### gck_enumerator_get_object_type

Get the type of objects created by this enumerator. The type will always either be `GckObject` or derived from it.

###### gck_enumerator_next

Get the next object in the enumerator, or `NULL` if there are no more objects.

###### gck_enumerator_next_async

Get the next set of objects from the enumerator. This operation completes asynchronously.The maximum number of objects can be specified with `max_objects`. If -1 is specified, then all the remaining objects will be enumerated.

###### gck_enumerator_next_finish

Complete an operation to enumerate next objects.

###### gck_enumerator_next_n

Get the next set of objects from the enumerator. The maximum number of objects can be specified with `max_objects`. If -1 is specified, then all the remaining objects will be returned.

###### gck_enumerator_set_chained

Set a chained enumerator that will be run after all objects from this one are seen.

###### gck_enumerator_set_interaction

Set the interaction used when a pin is needed.

###### gck_enumerator_set_object_type

Set the type of objects to be created by this enumerator. The type must always be either `GckObject` or derived from it.

###### gck_enumerator_set_object_type_full

Set the type of objects to be created by this enumerator. The type must always be either `GckObject` or derived from it.

##### Methods inherited from GObject (43)

Please see GObject for a full list of methods.

#### Properties

###### Gck.Enumerator:chained

Chained enumerator, which will be enumerated when this enumerator has enumerated all its objects.

###### Gck.Enumerator:interaction

Interaction object used to ask the user for pins when opening sessions. Used if the session_options of the enumerator have `GCK_SESSION_LOGIN_USER`.

###### Gck.Enumerator:object-type

The type of objects that are created by the enumerator. Must be GckObject or derived from it.

#### Signals

##### Signals inherited from GObject (1)

###### GObject::notify

The notify signal is emitted on an object when one of its properties has its value set through g_object_set_property(), g_object_set(), et al.

#### Class structure

    struct GckEnumeratorClass {
      GObjectClass parent_class;

    }

No description available.

###### Class members

`parent_class: GObjectClass`

  No description available.